<?php
/**
 * Marker Pen Styles buttons
 *
 * @author Eduard Diaz <edudiaz@scopia.es>
 */

if (!defined('DOKU_INC')) die();
if (!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN', DOKU_INC . 'lib/plugins/');
require_once (DOKU_PLUGIN . 'action.php');

class action_plugin_markerpen extends DokuWiki_Action_Plugin {

    /**
     * Return some info
     */
    function getInfo() {
        return array (
            'author' => 'Eduard Diaz',
            'email'  => 'edudiaz@scopia.es',
            'date'   => '05-10-2009',
            'name'   => 'Marker pen button',
            'desc'   => 'Inserts a buttons into the toolbar',
            'url'    => 'http://www.scopia.es',
        );
    }

    /**
     * Register the eventhandlers
     */
    function register(&$controller) {
        $controller->register_hook('TOOLBAR_DEFINE', 'AFTER', $this, 'markerpen_button', array ());
    }

    /**
     * Inserts the toolbar button
     */
    function markerpen_button(& $event, $param) {
        $event->data[] = array (
            'type' => 'format',
            'title' => $this->getLang('highlighter_btn'),
            'icon' => '../../plugins/markerpen/ico_markerpen.png',
            'open' => '<groc>',
            'close' => '</groc>',
        );
    }
}
