<?php
/**
 * Markerpen : groc class to a content
 *
 * Syntax: <groc>content</groc>
 *
 * @author     Eduard Diaz <edudiaz@scopia.es>
 * @license    GPL 2 (http://www.gnu.org/licenses/gpl.html)
 */

// must be run within Dokuwiki
if(!defined('DOKU_INC')) die();

if(!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');
require_once(DOKU_PLUGIN.'syntax.php');



class syntax_plugin_markerpen extends DokuWiki_Syntax_Plugin {

   /**
    * Get an associative array with plugin info.
    */

    function getInfo(){
        return array(
            'author' => 'Eduard Diaz',
            'email'  => 'edudiaz@scopia.es',
            'date'   => '05-10-2009',
            'name'   => 'Marker Pen Syntax Plugin',
            'desc'   => 'Plugin to add highlighter',
            'url'    => 'http://www.scopia.es/',
        );
    }

    function getType(){ return 'formatting'; }
    //function getPType(){ return 'block'; }
    //'container','substition','protected','disabled','baseonly','formatting','paragraphs'
    function getAllowedTypes() {
        return array('formatting','substition','disabled');
    }
    function getSort(){ return 34; }


    /**
     * Connect pattern to lexer
     */
    function connectTo($mode) {
        $this->Lexer->addEntryPattern('<groc>(?=.*</groc>)',$mode,'plugin_markerpen');
    }
    function postConnect() {
        $this->Lexer->addExitPattern('</groc>','plugin_markerpen');
    }

    /**
     * Handle the match
     */

    function handle($match, $state, $pos, &$handler){

        switch ($state) {

          case DOKU_LEXER_ENTER :
            return array( $state, trim(substr($match,6,-1)) );

          case DOKU_LEXER_UNMATCHED :
            return array($state, $match);

          default:
            return array($state);
        }
    }

   /**
    * output
    */
    function render($mode, &$renderer, $indata) {
        if($mode == 'xhtml'){

          list($state, $data) = $indata;
          switch ($state) {
            case DOKU_LEXER_ENTER :
                $renderer->doc .= '<span class="groc">'.$renderer->_xmlEntities(trim($data));
                break;
            case DOKU_LEXER_UNMATCHED :
                $renderer->doc .=$renderer->_xmlEntities(trim($data));
                break;

            case DOKU_LEXER_EXIT :
                $renderer->doc .= "</span>";
                break;
          }

          return true;

        }
        return false;
    }

}
?>
